<?php
/*
SMF Flickr Gallery Browser Mod
Version 0.3
November 2008
P.J.Lawrence
*/

if (!defined('SMF'))
	die('Hacking attempt...');

require_once("phpFlickr/phpFlickr.php");
//
// Extract the public sets from a Flickr account
//
function getSets($person,$f)
{
	$photosets = $f->photosets_getList($person['id']);
	$sets = array();
	$i = 0;
	foreach ((array)$photosets['photoset'] as $photoset)
	{
		$info = $f->photos_getInfo($photoset['primary']);
		
		$row = array();		
		$row['id'] = $i;
		$row['title'] = $photoset['title'];
		$row['description'] = $photoset['description'];
		$row['thumbnail'] = "http://static.flickr.com/$photoset[server]/$photoset[primary]_$photoset[secret]_s.jpg";	
		$row['slug'] = $photoset['id'];
	
		$sets[$i] = $row;
		$i++;
	}
	return $sets;
}
//
// extract the photos from a Flickr set: title, description, thumbnails, url
//
function getFlickrPhotos($person,$f,$photoset_id,$title) 
{
	$setphotos = $f->photosets_getPhotos($photoset_id, NULL, NULL);
	$setinfo=$f->photosets_getInfo($photoset_id);
	$title=$setinfo['title'];
	
	$photos = array();
	$i = 0;
	foreach ((array)$setphotos['photo'] as $photo)
	{
			$info = $f->photos_getInfo($photo['id']);
			$image_size=$f->photos_getSizes($photo['id']);
			$row = array();		
			$row['id'] = $i;			
			$row['gid'] = $photo['id'];
			$row['title'] = $photo['title'];
			$row['height'] = $image_size[4]['height']; 
			$row['width'] = $image_size[4]['width']; 
			$row['size'] = '10'; //round($photo['gphoto']['size']/102.40)/10.0;
			$row['timestamp'] = $info['dates']['posted'];// lastupdate
			$row['taken'] = $info['dates']['taken'];
			$row['description'] = $info['description'];
			$row['thumbnail72'] = $f->buildPhotoURL($photo, "square");
			$row['thumbnail144'] = $f->buildPhotoURL($photo, "thumbnail");
			$row['thumbnail288'] = $f->buildPhotoURL($photo, "small");
			$row['url'] = $f->buildPhotoURL($photo, "medium");

			$photos[$i] = $row;
			$i++;
	}
	return $photos;
}
//
//  Removes a parameter from a URL
//
function RemoveFromUrl($TheURL,$TheParm)
{
	if (strpos($TheURL, "&{$TheParm}=")==false) // remove $TheParm]tag
	{
		if (strpos($TheURL, "?{$TheParm}=")!=false)
		{
			if (strpos($TheURL, '&')==false)
			{
				$TheURL = str_replace("?{$TheParm}=".$_GET["$TheParm"],'',$TheURL); // remove $TheParm link
			}
			else
			{
				$TheURL = str_replace("?{$TheParm}=".$_GET["$TheParm"].'&','?',$TheURL); // remove $TheParm link
			}
		}
		else if (strpos($TheURL, "/{$TheParm},")!=false) //  using search engine friendly URLs
		{
			$TheURL = str_replace("/{$TheParm},".$_GET["$TheParm"],'',$TheURL); // remove $TheParm link
		}
	}
	else
	{
		$TheURL = str_replace("&{$TheParm}=".$_GET["$TheParm"],'',$TheURL); // remove $TheParm link
	}
	return ($TheURL);
}
//
//  Formats a parameter for use in a URL
//
function FormatParmForUrl($TheURL,$TheParm,$UsingOldSearchFriendlyURLs=0)
{
	if ($UsingOldSearchFriendlyURLs==1) //  using search engine friendly URLs
	{
		$TheParm="/{$TheParm},";
	}
	elseif (strpos($TheURL , '?')==false)
	{
		$TheParm="?{$TheParm}=";
	}
	else
	{
		$TheParm="&amp;{$TheParm}=";
	}
	return ($TheParm);
}
//
// Main template code
//
function FlickrGalleryBrowser()
{
	// SMF Globals
	global $modSettings,$context,$mbname, $txt, $scripturl,$settings;
	
	// Flickr Browser Globals
	global $FlickrSetID,$FlickrSetTitle,$UsingOldSearchFriendlyURLs,$FlickrCols,$FlickrUserURL;
	global $FlickrPhotos,$FlickrSets,$FlickrErrorMessage,$FlickrServerURL,$FlickrPhotoURL;
	global $FlickrWarningMessage;
	
	// Set the page title
	$context['page_title'] = $mbname . ' ' . $txt['flickr_table_title'];
	
	// Link Tree
	if (empty($modSettings['gallery_flickr_fixed_set']) && !empty($modSettings['gallery_flickr_default_set']))
	{
		$context['linktree'][] = array(
						'url' => $scripturl . '?action=flickrgallerybrowser&ListSets=1',
						'name' => $txt['flickr_table_title']
					);
	}
	else
	{
		$context['linktree'][] = array(
						'url' => $scripturl . '?action=flickrgallerybrowser',
						'name' => $txt['flickr_table_title']
					);
	}
	
	$FlickrAPIKey='';
	$FlickrSetTitle='';
	// check settings
	if (empty($modSettings['gallery_flickr_API_Key']))
	{	
	    $FlickrErrorMessage = '<br /><b>'.$txt['no_flickr_APIKey'].'</b><br />';
	}
	else
	{
		$FlickrAPIKey = $modSettings['gallery_flickr_API_Key']; // Link to your Flickr Server URL
		$f = new phpFlickr($FlickrAPIKey);
	
	    //  If selected enable cacheing 
		$DBCacheEnabled=FALSE;
		if (!empty($modSettings['gallery_flickr_enable_db_catch']))
		{
			// Database cache: Supports all SMF databases types MySQL,PostgreSQL and SQLite, plus many more
			global $db_type,$db_server,$db_name,$db_user,$db_passwd;
			if (empty($db_type))
			{
				// smf 1 database, mysql only
				$DBCacheEnabled=$f->enableCache("db","mysql://$db_user:$db_passwd@$db_server/$db_name");
			}
			else
			{
				// smf 2 database
				if ($db_type == 'postgresql') // this acronym is different for SMF and PEAR lib 
				{
					$DBCacheEnabled=$f->enableCache("db","pgsql://$db_user:$db_passwd@$db_server/$db_name");
				}
				else
				{
					$DBCacheEnabled=$f->enableCache("db","$db_type://$db_user:$db_passwd@$db_server/$db_name");
				}
			}
			if (!$DBCacheEnabled)
			{
				$FlickrWarningMessage=$txt['flickr_db_cache_failed'];
			}
		}
		
		if (!$DBCacheEnabled)
		{
			// if DB cache not working try File cache option if enabled
			if (!empty($modSettings['gallery_flickr_enable_file_catch']) && !empty($modSettings['gallery_flickr_cache_folder']))
			{
				$FSCacheEnabled=FALSE;
				if (file_exists ($modSettings['gallery_flickr_cache_folder']))
				{
					$FSCacheEnabled=$f->enableCache("fs", $modSettings['gallery_flickr_cache_folder']);
				}

				if (!$FSCacheEnabled)
				{
					if (empty($FlickrWarningMessage))
					{
						$FlickrWarningMessage=$txt['flickr_fs_cache_failed'];
					}
					else
					{
						$FlickrWarningMessage.="<br />{$txt['flickr_fs_cache_failed']}";
					}
				}
			}
		}
	}
	
	$FlickrPhotoURL = '';
	if (empty($modSettings['gallery_flickr_account']))
	{	
		$FlickrErrorMessage .= '<br /><b>'.$txt['no_flickr_account'].'</b><br />';
	}
	else
	{
		if (!empty($f))
		{
			$FlickrID = $modSettings['gallery_flickr_account'];
			
			$person = $f->people_findByUsername($FlickrID);
			if (!empty($person))
			{
				$PersonInfo=$f->people_getInfo($person['id']);
				if (!empty($PersonInfo))
				{
					$FlickrPhotoURL =  $PersonInfo['photosurl'];
				}
			}
		}
	}

	if (empty($modSettings['gallery_flickr_columns']) || $modSettings['gallery_flickr_columns']<1)
	{
		$FlickrCols = 6;
	}
	else
	{
		$FlickrCols = $modSettings['gallery_flickr_columns'];
	}
	
	if (!empty($FlickrErrorMessage))
	{
		// Error message 
		// Load the main flickr gallery template and finish
		loadtemplate('flickrgallerybrowser');
		return;
	}
	
	// see what should be displayed
	if (!empty($modSettings['gallery_flickr_default_set']))
	{
		// default set specified
		if (empty($_GET['ListSets']) || !empty($modSettings['gallery_flickr_fixed_set']))
		{
			// identify set id
			$FlickrSets=getSets($person,$f);
			if (empty($FlickrSets))
			{
				$FlickrErrorMessage = '<br /><b>'.$txt['no_flickr_sets'].'</b><br />';
				loadtemplate('flickrgallerybrowser');
				return;
			}
			else
			{
				$FlickrSetID = $modSettings['gallery_flickr_default_set'];
				foreach($FlickrSets as $set) 
				{
					if ($modSettings['gallery_flickr_default_set']==$set['title'])
					{
						$FlickrSetID = $set['slug'];
					}
				}
			}
		}
	}
	if (empty($modSettings['gallery_flickr_fixed_set']))
	{
		if (!empty($_GET['ListSets']))
		{
			if ($_GET['ListSets']=='1')
			{
				$FlickrSetID='';
			}
		}
		
		if (!empty($_GET['setid']))
		{
			$FlickrSetID = $_GET['setid'];
		}
	}
	else
	{
		if (empty($FlickrSetID))
		{
			$FlickrErrorMessage = '<br /><b>'.$txt['no_flickr_default_set'].'</b><br />';
			loadtemplate('flickrgallerybrowser');
			return;
		}
	}
	
	// find out what format the URL is in.
	$FlickrUserURL = $_SERVER["REQUEST_URI"];
	$UsingOldSearchFriendlyURLs=0;
	if (strpos($FlickrUserURL, '/action,')!=false && strpos($FlickrUserURL, '.html')==false && strpos($FlickrUserURL, 'index.php')!=false)
	{
		$UsingOldSearchFriendlyURLs=1; //  using old search engine friendly URLs
	}
	
	if (!empty($FlickrSetID))
	{	
		$FlickrSetURL=$FlickrUserURL;
		$FlickrUserURL=RemoveFromUrl($FlickrUserURL,'setid');

		//	3) These CSS-styles are necessary for the script to work. You may also put
		//	them in an external CSS-file. See the webpage for documentation.
	
		$context['html_headers'] =  $context['html_headers'] . '
		<link rel="stylesheet" type="text/css" href="'.$settings['default_theme_url'].'/flickrhighslide/flickrhs.css" />';
		$FlickrPhotos = getFlickrPhotos($person,$f,$FlickrSetID,&$FlickrSetTitle);	
		//echo '$FlickrSetTitle ',$FlickrSetTitle; echo '<br />';
		if (empty($modSettings['gallery_flickr_fixed_set']))
		{
			// Add link tree if they can browse sets
			if (empty($FlickrSetTitle))
			{
				$context['linktree'][] = array(
							'url' => $FlickrSetURL,
							'name' => $FlickrSetID
						);
			}
			else
			{
				$context['linktree'][] = array(
							'url' => $FlickrSetURL,
							'name' => $FlickrSetTitle
						);
			}
		}
	}
	else
	{
		$FlickrSets=getSets($person,$f);
	}
	
	if (!empty($_GET['ListSets'])) // remove ListSets tag
	{
	    $FlickrUserURL=RemoveFromUrl($FlickrUserURL,'ListSets');
	}
	
	// Load the main flickr gallery template
	loadtemplate('flickrgallerybrowser');
}
?>